import type { AtRuleNameCaseOptions } from './rules/at-rule-name-case'
import type { AtRuleNameNewlineAfterOptions } from './rules/at-rule-name-newline-after'
import type { AtRuleNameSpaceAfterOptions } from './rules/at-rule-name-space-after'
import type { AtRuleSemicolonNewlineAfterOptions } from './rules/at-rule-semicolon-newline-after'
import type { AtRuleSemicolonSpaceBeforeOptions } from './rules/at-rule-semicolon-space-before'
import type { BlockClosingBraceNewlineAfterOptions } from './rules/block-closing-brace-newline-after'
import type { BlockClosingBraceEmptyLineBeforeOptions } from './rules/block-closing-brace-empty-line-before'
import type { BlockClosingBraceNewlineBeforeOptions } from './rules/block-closing-brace-newline-before'
import type { BlockClosingBraceSpaceAfterOptions } from './rules/block-closing-brace-space-after'
import type { BlockClosingBraceSpaceBeforeOptions } from './rules/block-closing-brace-space-before'
import type { BlockOpeningBraceNewlineAfterOptions } from './rules/block-opening-brace-newline-after'
import type { BlockOpeningBraceNewlineBeforeOptions } from './rules/block-opening-brace-newline-before'
import type { BlockOpeningBraceSpaceAfterOptions } from './rules/block-opening-brace-space-after'
import type { BlockOpeningBraceSpaceBeforeOptions } from './rules/block-opening-brace-space-before'
import type { ColorHexCaseOptions } from './rules/color-hex-case'
import type { DeclarationBangSpaceAfterOptions } from './rules/declaration-bang-space-after'
import type { DeclarationBangSpaceBeforeOptions } from './rules/declaration-bang-space-before'
import type { DeclarationBlockSemicolonNewlineAfterOptions } from './rules/declaration-block-semicolon-newline-after'
import type { DeclarationBlockSemicolonNewlineBeforeOptions } from './rules/declaration-block-semicolon-newline-before'
import type { DeclarationBlockSemicolonSpaceAfterOptions } from './rules/declaration-block-semicolon-space-after'
import type { DeclarationBlockSemicolonSpaceBeforeOptions } from './rules/declaration-block-semicolon-space-before'
import type { DeclarationBlockTrailingSemicolonOptions } from './rules/declaration-block-trailing-semicolon'
import type { DeclarationColonNewlineAfterOptions } from './rules/declaration-colon-newline-after'
import type { DeclarationColonSpaceAfterOptions } from './rules/declaration-colon-space-after'
import type { DeclarationColonSpaceBeforeOptions } from './rules/declaration-colon-space-before'
import type { FunctionCommaNewlineAfterOptions } from './rules/function-comma-newline-after'
import type { FunctionCommaNewlineBeforeOptions } from './rules/function-comma-newline-before'
import type { FunctionCommaSpaceAfterOptions } from './rules/function-comma-space-after'
import type { FunctionCommaSpaceBeforeOptions } from './rules/function-comma-space-before'
import type { FunctionMaxEmptyLinesOptions } from './rules/function-max-empty-lines'
import type { FunctionParenthesesNewlineInsideOptions } from './rules/function-parentheses-newline-inside'
import type { FunctionParenthesesSpaceInsideOptions } from './rules/function-parentheses-space-inside'
import type { FunctionWhitespaceAfterOptions } from './rules/function-whitespace-after'
import type { IndentationOptions } from './rules/indentation'
import type { LinebreaksOptions } from './rules/linebreaks'
import type { MaxEmptyLinesOptions } from './rules/max-empty-lines'
import type { MaxLineLengthOptions } from './rules/max-line-length'
import type { MediaFeatureColonSpaceAfterOptions } from './rules/media-feature-colon-space-after'
import type { MediaFeatureColonSpaceBeforeOptions } from './rules/media-feature-colon-space-before'
import type { MediaFeatureNameCaseOptions } from './rules/media-feature-name-case'
import type { MediaFeatureParenthesesSpaceInsideOptions } from './rules/media-feature-parentheses-space-inside'
import type { MediaFeatureRangeOperatorSpaceAfterOptions } from './rules/media-feature-range-operator-space-after'
import type { MediaFeatureRangeOperatorSpaceBeforeOptions } from './rules/media-feature-range-operator-space-before'
import type { MediaQueryListCommaNewlineAfterOptions } from './rules/media-query-list-comma-newline-after'
import type { MediaQueryListCommaNewlineBeforeOptions } from './rules/media-query-list-comma-newline-before'
import type { MediaQueryListCommaSpaceAfterOptions } from './rules/media-query-list-comma-space-after'
import type { MediaQueryListCommaSpaceBeforeOptions } from './rules/media-query-list-comma-space-before'
import type { NoEmptyFirstLineOptions } from './rules/no-empty-first-line'
import type { NoEolWhitespaceOptions } from './rules/no-eol-whitespace'
import type { NoExtraSemicolonsOptions } from './rules/no-extra-semicolons'
import type { NoMissingEndOfSourceNewlineOptions } from './rules/no-missing-end-of-source-newline'
import type { NumberLeadingZeroOptions } from './rules/number-leading-zero'
import type { NumberNoTrailingZerosOptions } from './rules/number-no-trailing-zeros'
import type { PropertyCaseOptions } from './rules/property-case'
import type { SelectorAttributeBracketsSpaceInsideOptions } from './rules/selector-attribute-brackets-space-inside'
import type { SelectorAttributeOperatorSpaceAfterOptions } from './rules/selector-attribute-operator-space-after'
import type { SelectorAttributeOperatorSpaceBeforeOptions } from './rules/selector-attribute-operator-space-before'
import type { SelectorCombinatorSpaceAfterOptions } from './rules/selector-combinator-space-after'
import type { SelectorCombinatorSpaceBeforeOptions } from './rules/selector-combinator-space-before'
import type { SelectorDescendantCombinatorNoNonSpaceOptions } from './rules/selector-descendant-combinator-no-non-space'
import type { SelectorListCommaNewlineAfterOptions } from './rules/selector-list-comma-newline-after'
import type { SelectorListCommaNewlineBeforeOptions } from './rules/selector-list-comma-newline-before'
import type { SelectorListCommaSpaceAfterOptions } from './rules/selector-list-comma-space-after'
import type { SelectorListCommaSpaceBeforeOptions } from './rules/selector-list-comma-space-before'
import type { SelectorMaxEmptyLinesOptions } from './rules/selector-max-empty-lines'
import type { SelectorPseudoClassCaseOptions } from './rules/selector-pseudo-class-case'
import type { SelectorPseudoClassParenthesesSpaceInsideOptions } from './rules/selector-pseudo-class-parentheses-space-inside'
import type { SelectorPseudoElementCaseOptions } from './rules/selector-pseudo-element-case'
import type { StringQuotesOptions } from './rules/string-quotes'
import type { UnicodeBomOptions } from './rules/unicode-bom'
import type { UnitCaseOptions } from './rules/unit-case'
import type { ValueListCommaNewlineAfterOptions } from './rules/value-list-comma-newline-after'
import type { ValueListCommaNewlineBeforeOptions } from './rules/value-list-comma-newline-before'
import type { ValueListCommaSpaceAfterOptions } from './rules/value-list-comma-space-after'
import type { ValueListCommaSpaceBeforeOptions } from './rules/value-list-comma-space-before'
import type { ValueListMaxEmptyLinesOptions } from './rules/value-list-max-empty-lines'

export interface Plugins {
  'stylelint-codeguide': void
}

export interface RuleOptions {
  /**
   * Specify lowercase or uppercase for at-rules names.
   *
   * Only lowercase at-rule names are valid in SCSS.
   *
   * @see [at-rule-name-case](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/at-rule-name-case/README.md)
   */
  'codeguide/at-rule-name-case': AtRuleNameCaseOptions

  /**
   * Require a newline after at-rule names.
   *
   * @see [at-rule-name-newline-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/at-rule-name-newline-after/README.md)
   */
  'codeguide/at-rule-name-newline-after': AtRuleNameNewlineAfterOptions

  /**
   * Require a single space after at-rule names.
   *
   * @see [at-rule-name-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/at-rule-name-space-after/README.md)
   */
  'codeguide/at-rule-name-space-after': AtRuleNameSpaceAfterOptions

  /**
   * Require a newline after the semicolon of at-rules.
   *
   * This rule allows an end-of-line comment followed by a newline.
   *
   * @see [at-rule-semicolon-newline-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/at-rule-semicolon-newline-after/README.md)
   */
  'codeguide/at-rule-semicolon-newline-after': AtRuleSemicolonNewlineAfterOptions

  /**
   * Require a single space or disallow whitespace before the semicolons of at-rules.
   *
   * @see [at-rule-semicolon-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/at-rule-semicolon-space-before/README.md)
   */
  'codeguide/at-rule-semicolon-space-before': AtRuleSemicolonSpaceBeforeOptions

  /**
   * Require a newline or disallow whitespace after the closing brace of blocks.
   *
   * This rule allows an end-of-line comment separated from the closing brace by spaces, as long as the comment contains no newlines.
   *
   * This rule allows a trailing semicolon after the closing brace of a block.
   *
   * @see [block-closing-brace-newline-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/block-closing-brace-newline-after/README.md)
   */
  'codeguide/block-closing-brace-newline-after': BlockClosingBraceNewlineAfterOptions

  /**
   * Require or disallow an empty line before the closing brace of blocks.
   *
   * @see [block-closing-brace-empty-line-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/block-closing-brace-empty-line-before/README.md)
   */
  'codeguide/block-closing-brace-empty-line-before': BlockClosingBraceEmptyLineBeforeOptions

  /**
   * Require a newline or disallow whitespace before the closing brace of blocks.
   *
   * @see [block-closing-brace-newline-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/block-closing-brace-newline-before/README.md)
   */
  'codeguide/block-closing-brace-newline-before': BlockClosingBraceNewlineBeforeOptions

  /**
   * Require a single space or disallow whitespace after the closing brace of blocks.
   *
   * This rule allows a trailing semicolon after the closing brace of a block.
   *
   * @see [block-closing-brace-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/block-closing-brace-space-after/README.md)
   */
  'codeguide/block-closing-brace-space-after': BlockClosingBraceSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the closing brace of blocks.
   *
   * @see [block-closing-brace-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/block-closing-brace-space-before/README.md)
   */
  'codeguide/block-closing-brace-space-before': BlockClosingBraceSpaceBeforeOptions

  /**
   * Require a newline after the opening brace of blocks.
   *
   * This rule allows an end-of-line comment followed by a newline.
   *
   * @see [block-opening-brace-newline-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/block-opening-brace-newline-after/README.md)
   */
  'codeguide/block-opening-brace-newline-after': BlockOpeningBraceNewlineAfterOptions

  /**
   * Require a newline or disallow whitespace before the opening brace of blocks.
   *
   * @see [block-opening-brace-newline-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/block-opening-brace-newline-before/README.md)
   */
  'codeguide/block-opening-brace-newline-before': BlockOpeningBraceNewlineBeforeOptions

  /**
   * Require a single space or disallow whitespace after the opening brace of blocks.
   *
   * @see [block-opening-brace-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/block-opening-brace-space-after/README.md)
   */
  'codeguide/block-opening-brace-space-after': BlockOpeningBraceSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the opening brace of blocks.
   *
   * @see [block-opening-brace-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/block-opening-brace-space-before/README.md)
   */
  'codeguide/block-opening-brace-space-before': BlockOpeningBraceSpaceBeforeOptions

  /**
   * Specify lowercase or uppercase for hex colors.
   *
   * @see [color-hex-case](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/color-hex-case/README.md)
   */
  'codeguide/color-hex-case': ColorHexCaseOptions

  /**
   * Require a single space or disallow whitespace after the bang of declarations.
   *
   * @see [declaration-bang-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/declaration-bang-space-after/README.md)
   */
  'codeguide/declaration-bang-space-after': DeclarationBangSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the bang of declarations.
   *
   * @see [declaration-bang-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/declaration-bang-space-before/README.md)
   */
  'codeguide/declaration-bang-space-before': DeclarationBangSpaceBeforeOptions

  /**
   * Require a newline or disallow whitespace after the semicolons of declaration blocks.
   *
   * @see [declaration-block-semicolon-newline-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/declaration-block-semicolon-newline-after/README.md)
   */
  'codeguide/declaration-block-semicolon-newline-after': DeclarationBlockSemicolonNewlineAfterOptions

  /**
   * Require a newline or disallow whitespace before the semicolons of declaration blocks.
   *
   * @see [declaration-block-semicolon-newline-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/declaration-block-semicolon-newline-before/README.md)
   */
  'codeguide/declaration-block-semicolon-newline-before': DeclarationBlockSemicolonNewlineBeforeOptions

  /**
   * Require a single space or disallow whitespace after the semicolons of declaration blocks.
   *
   * This rule ignores:
   *
   * - semicolons that are preceded by Less mixins
   * - the last semicolon of declaration blocks
   *
   * Use the `block-closing-brace-*-before` rules to control the whitespace between the last semicolon and the closing brace instead.
   *
   * @see [declaration-block-semicolon-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/declaration-block-semicolon-space-after/README.md)
   */
  'codeguide/declaration-block-semicolon-space-after': DeclarationBlockSemicolonSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the semicolons of declaration blocks.
   *
   * This rule ignores semicolons that are preceded by Less mixins.
   *
   * @see [declaration-block-semicolon-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/declaration-block-semicolon-space-before/README.md)
   */
  'codeguide/declaration-block-semicolon-space-before': DeclarationBlockSemicolonSpaceBeforeOptions

  /**
   * Require or disallow a trailing semicolon within declaration blocks.
   *
   * The trailing semicolon is the _last_ semicolon in a declaration block and it is optional.
   *
   *This rule ignores:
   *
   * - Less mixins
   * - trailing `//` comments
   * - declaration blocks containing nested (at-)rules
   *
   * @see [declaration-block-trailing-semicolon](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/declaration-block-trailing-semicolon/README.md)
   */
  'codeguide/declaration-block-trailing-semicolon': DeclarationBlockTrailingSemicolonOptions

  /**
   * Require a newline or disallow whitespace after the colon of declarations.
   *
   * @see [declaration-colon-newline-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/declaration-colon-newline-after/README.md)
   */
  'codeguide/declaration-colon-newline-after': DeclarationColonNewlineAfterOptions

  /**
   * Require a single space or disallow whitespace after the colon of declarations.
   *
   * @see [declaration-colon-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/declaration-colon-space-after/README.md)
   */
  'codeguide/declaration-colon-space-after': DeclarationColonSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the colon of declarations.
   *
   * @see [declaration-colon-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/declaration-colon-space-before/README.md)
   */
  'codeguide/declaration-colon-space-before': DeclarationColonSpaceBeforeOptions

  /**
   * Require a newline or disallow whitespace after the commas of functions.
   *
   * @see [function-comma-newline-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/function-comma-newline-after/README.md)
   */
  'codeguide/function-comma-newline-after': FunctionCommaNewlineAfterOptions

  /**
   * Require a newline or disallow whitespace before the commas of functions.
   *
   * @see [function-comma-newline-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/function-comma-newline-before/README.md)
   */
  'codeguide/function-comma-newline-before': FunctionCommaNewlineBeforeOptions

  /**
   * Require a single space or disallow whitespace after the commas of functions.
   *
   * @see [function-comma-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/function-comma-space-after/README.md)
   */
  'codeguide/function-comma-space-after': FunctionCommaSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the commas of functions.
   *
   * @see [function-comma-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/function-comma-space-before/README.md)
   */
  'codeguide/function-comma-space-before': FunctionCommaSpaceBeforeOptions

  /**
   * Limit the number of adjacent empty lines within functions.
   *
   * @see [function-max-empty-lines](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/function-max-empty-lines/README.md)
   */
  'codeguide/function-max-empty-lines': FunctionMaxEmptyLinesOptions

  /**
   * Require a newline or disallow whitespace on the inside of the parentheses of functions.
   *
   * @see [function-parentheses-newline-inside](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/function-parentheses-newline-inside/README.md)
   */
  'codeguide/function-parentheses-newline-inside': FunctionParenthesesNewlineInsideOptions

  /**
   * Require a single space or disallow whitespace on the inside of the parentheses of functions.
   *
   * @see [function-parentheses-space-inside](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/function-parentheses-space-inside/README.md)
   */
  'codeguide/function-parentheses-space-inside': FunctionParenthesesSpaceInsideOptions

  /**
   * Require or disallow whitespace after functions.
   *
   * This rule does not check for space immediately after `)` if the very next character is `,`, `)`, `/` or `}`, allowing some of the patterns exemplified below.
   *
   * @see [function-whitespace-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/function-whitespace-after/README.md)
   */
  'codeguide/function-whitespace-after': FunctionWhitespaceAfterOptions

  /**
   * Specify indentation.
   *
   * @see [indentation](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/indentation/README.md)
   */
  'codeguide/indentation': IndentationOptions

  /**
   * Specify unix or windows linebreaks.
   *
   * The [`fix` option](https://stylelint.io/user-guide/options#fix) can automatically fix all of the problems reported by this rule.
   *
   * @see [linebreaks](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/linebreaks/README.md)
   */
  'codeguide/linebreaks': LinebreaksOptions

  /**
   * Limit the number of adjacent empty lines.
   *
   * @see [max-empty-lines](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/max-empty-lines/README.md)
   */
  'codeguide/max-empty-lines': MaxEmptyLinesOptions

  /**
   * Limit the length of a line.
   *
   * @see [max-line-length](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/max-line-length/README.md)
   */
  'codeguide/max-line-length': MaxLineLengthOptions

  /**
   * Require a single space or disallow whitespace after the colon in media features.
   *
   * @see [media-feature-colon-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/media-feature-colon-space-after/README.md)
   */
  'codeguide/media-feature-colon-space-after': MediaFeatureColonSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the colon in media features.
   *
   * @see [media-feature-colon-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/media-feature-colon-space-before/README.md)
   */
  'codeguide/media-feature-colon-space-before': MediaFeatureColonSpaceBeforeOptions

  /**
   * Specify lowercase or uppercase for media feature names.
   *
   * @see [media-feature-name-case](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/media-feature-name-case/README.md)
   */
  'codeguide/media-feature-name-case': MediaFeatureNameCaseOptions

  /**
   * Require a single space or disallow whitespace on the inside of the parentheses within media features.
   *
   * @see [media-feature-parentheses-space-inside](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/media-feature-parentheses-space-inside/README.md)
   */
  'codeguide/media-feature-parentheses-space-inside': MediaFeatureParenthesesSpaceInsideOptions

  /**
   * Require a single space or disallow whitespace after the range operator in media features.
   *
   * @see [media-feature-range-operator-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/media-feature-range-operator-space-after/README.md)
   */
  'codeguide/media-feature-range-operator-space-after': MediaFeatureRangeOperatorSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the range operator in media features.
   *
   * @see [media-feature-range-operator-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/media-feature-range-operator-space-before/README.md)
   */
  'codeguide/media-feature-range-operator-space-before': MediaFeatureRangeOperatorSpaceBeforeOptions

  /**
   * Require a newline or disallow whitespace after the commas of media query lists.
   *
   * @see [media-query-list-comma-newline-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/media-query-list-comma-newline-after/README.md)
   */
  'codeguide/media-query-list-comma-newline-after': MediaQueryListCommaNewlineAfterOptions

  /**
   * Require a newline or disallow whitespace before the commas of media query lists.
   *
   * @see [media-query-list-comma-newline-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/media-query-list-comma-newline-before/README.md)
   */
  'codeguide/media-query-list-comma-newline-before': MediaQueryListCommaNewlineBeforeOptions

  /**
   * Require a single space or disallow whitespace after the commas of media query lists.
   *
   * @see [media-query-list-comma-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/media-query-list-comma-space-after/README.md)
   */
  'codeguide/media-query-list-comma-space-after': MediaQueryListCommaSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the commas of media query lists.
   *
   * @see [media-query-list-comma-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/media-query-list-comma-space-before/README.md)
   */
  'codeguide/media-query-list-comma-space-before': MediaQueryListCommaSpaceBeforeOptions

  /**
   * Disallow empty first lines.
   *
   * This rule ignores empty sources. Use the [`no-empty-source`](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/no-empty-source/README.md) rule to disallow these.
   *
   * @see [no-empty-first-line](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/no-empty-first-line/README.md)
   */
  'codeguide/no-empty-first-line': NoEmptyFirstLineOptions

  /**
   * Disallow end-of-line whitespace.
   *
   * @see [no-eol-whitespace](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/no-eol-whitespace/README.md)
   */
  'codeguide/no-eol-whitespace': NoEolWhitespaceOptions

  /**
   * Disallow extra semicolons.
   *
   * This rule ignores semicolons after Less mixins.
   *
   * @see [no-extra-semicolons](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/no-extra-semicolons/README.md)
   */
  'codeguide/no-extra-semicolons': NoExtraSemicolonsOptions

  /**
   * Disallow missing end-of-source newlines.
   *
   * Completely empty files are not considered problems.
   *
   * @see [no-missing-end-of-source-newline](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/no-missing-end-of-source-newline/README.md)
   */
  'codeguide/no-missing-end-of-source-newline': NoMissingEndOfSourceNewlineOptions

  /**
   * Require or disallow a leading zero for fractional numbers less than 1.
   *
   * This rule ignores mixin parameters in Less.
   *
   * @see [number-leading-zero](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/number-leading-zero/README.md)
   */
  'codeguide/number-leading-zero': NumberLeadingZeroOptions

  /**
   * Disallow trailing zeros in numbers.
   *
   * @see [number-no-trailing-zeros](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/number-no-trailing-zeros/README.md)
   */
  'codeguide/number-no-trailing-zeros': NumberNoTrailingZerosOptions

  /**
   * Specify lowercase or uppercase for properties.
   *
   * @see [property-case](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/property-case/README.md)
   */
  'codeguide/property-case': PropertyCaseOptions

  /**
   * Require a single space or disallow whitespace on the inside of the brackets within attribute selectors.
   *
   * @see [selector-attribute-brackets-space-inside](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-attribute-brackets-space-inside/README.md)
   */
  'codeguide/selector-attribute-brackets-space-inside': SelectorAttributeBracketsSpaceInsideOptions

  /**
   * Require a single space or disallow whitespace after operators within attribute selectors.
   *
   * @see [selector-attribute-operator-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-attribute-operator-space-after/README.md)
   */
  'codeguide/selector-attribute-operator-space-after': SelectorAttributeOperatorSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before operators within attribute selectors.
   *
   * @see [selector-attribute-operator-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-attribute-operator-space-before/README.md)
   */
  'codeguide/selector-attribute-operator-space-before': SelectorAttributeOperatorSpaceBeforeOptions

  /**
   * Require a single space or disallow whitespace after the combinators of selectors.
   *
   * Combinators are used to combine several different selectors into new and more specific ones.
   * There are several types of combinators, including: child (`>`), adjacent sibling (`+`),
   *  general sibling (`~`), and descendant (which is represented by a blank space between two selectors).
   *
   * The descendant combinator is _not_ checked by this rule.
   *
   * Also, `+` and `-` signs within `:nth-*()` arguments are not checked (e.g. `a:nth-child(2n+1)`).
   *
   * @see [selector-combinator-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-combinator-space-after/README.md)
   */
  'codeguide/selector-combinator-space-after': SelectorCombinatorSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the combinators of selectors.
   *
   * Combinators are used to combine several different selectors into new and more specific ones.
   * There are several types of combinators, including: child (`>`), adjacent sibling (`+`),
   * general sibling (`~`), and descendant (which is represented by a blank space between two selectors).
   *
   * The descendant combinator is _not_ checked by this rule.
   *
   * Also, `+` and `-` signs within `:nth-*()` arguments are not checked (e.g. `a:nth-child(2n+1)`).
   *
   * @see [selector-combinator-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-combinator-space-before/README.md)
   */
  'codeguide/selector-combinator-space-before': SelectorCombinatorSpaceBeforeOptions

  /**
   * Disallow non-space characters for descendant combinators of selectors.
   *
   * This rule ensures that only a single space is used and ensures no tabs, newlines, nor multiple spaces are used for descendant combinators of selectors.
   *
   * @see [selector-descendant-combinator-no-non-space](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-descendant-combinator-no-non-space/README.md)
   */
  'codeguide/selector-descendant-combinator-no-non-space': SelectorDescendantCombinatorNoNonSpaceOptions

  /**
   * Require a newline or disallow whitespace after the commas of selector lists.
   *
   * End-of-line comments are allowed one space after the comma.
   *
   * @see [selector-list-comma-newline-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-list-comma-newline-after/README.md)
   */
  'codeguide/selector-list-comma-newline-after': SelectorListCommaNewlineAfterOptions

  /**
   * Require a newline or disallow whitespace before the commas of selector lists.
   *
   * @see [selector-list-comma-newline-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-list-comma-newline-before/README.md)
   */
  'codeguide/selector-list-comma-newline-before': SelectorListCommaNewlineBeforeOptions

  /**
   * Require a single space or disallow whitespace after the commas of selector lists.
   *
   * @see [selector-list-comma-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-list-comma-space-after/README.md)
   */
  'codeguide/selector-list-comma-space-after': SelectorListCommaSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the commas of selector lists.
   *
   * @see [selector-list-comma-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-list-comma-space-before/README.md)
   */
  'codeguide/selector-list-comma-space-before': SelectorListCommaSpaceBeforeOptions

  /**
   * Limit the number of adjacent empty lines within selectors.
   *
   * @see [selector-max-empty-lines](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-max-empty-lines/README.md)
   */
  'codeguide/selector-max-empty-lines': SelectorMaxEmptyLinesOptions

  /**
   * Specify lowercase or uppercase for pseudo-class selectors.
   *
   * @see [selector-pseudo-class-case](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-pseudo-class-case/README.md)
   */
  'codeguide/selector-pseudo-class-case': SelectorPseudoClassCaseOptions

  /**
   * Require a single space or disallow whitespace on the inside of the parentheses within pseudo-class selectors.
   *
   * @see [selector-pseudo-class-parentheses-space-inside](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-pseudo-class-parentheses-space-inside/README.md)
   */
  'codeguide/selector-pseudo-class-parentheses-space-inside': SelectorPseudoClassParenthesesSpaceInsideOptions

  /**
   * Specify lowercase or uppercase for pseudo-element selectors.
   *
   * @see [selector-pseudo-element-case](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/selector-pseudo-element-case/README.md)
   */
  'codeguide/selector-pseudo-element-case': SelectorPseudoElementCaseOptions

  /**
   * Specify single or double quotes around strings.
   *
   * Quotes within comments are ignored.
   *
   * Single quotes in a charset @-rule are ignored as using single quotes in this context is incorrect according the [CSS specification](https://www.w3.org/TR/CSS2/syndata.html#x57).
   *
   * @see [string-quotes](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/string-quotes/README.md)
   */
  'codeguide/string-quotes': StringQuotesOptions

  /**
   * Require or disallow the Unicode Byte Order Mark.
   *
   * @see [unicode-bom](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/unicode-bom/README.md)
   */
  'codeguide/unicode-bom': UnicodeBomOptions

  /**
   * Specify lowercase or uppercase for units.
   *
   * @see [unit-case](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/unit-case/README.md)
   */
  'codeguide/unit-case': UnitCaseOptions

  /**
   * Require a newline or disallow whitespace after the commas of value lists.
   *
   * @see [value-list-comma-newline-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/value-list-comma-newline-after/README.md)
   */
  'codeguide/value-list-comma-newline-after': ValueListCommaNewlineAfterOptions

  /**
   * Require a newline or disallow whitespace before the commas of value lists.
   *
   * @see [value-list-comma-newline-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/value-list-comma-newline-before/README.md)
   */
  'codeguide/value-list-comma-newline-before': ValueListCommaNewlineBeforeOptions

  /**
   * Require a single space or disallow whitespace after the commas of value lists.
   *
   * @see [value-list-comma-space-after](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/value-list-comma-space-after/README.md)
   */
  'codeguide/value-list-comma-space-after': ValueListCommaSpaceAfterOptions

  /**
   * Require a single space or disallow whitespace before the commas of value lists.
   *
   * @see [value-list-comma-space-before](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/value-list-comma-space-before/README.md)
   */
  'codeguide/value-list-comma-space-before': ValueListCommaSpaceBeforeOptions

  /**
   * Limit the number of adjacent empty lines within value lists.
   *
   * @see [value-list-max-empty-lines](https://github.com/firefoxic/stylelint-codeguide/blob/main/lib/rules/value-list-max-empty-lines/README.md)
   */
  'codeguide/value-list-max-empty-lines': ValueListMaxEmptyLinesOptions
}
